#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "includes.h"

REQ_TYPE *req;
LIMIT_TYPE *limit;
GLOBAL_TYPE *gl;
FIND_TYPE *find;

int findok(char*, char*);
int FindREQEXEC();
char execfile[PATH_MAX];
char rreq[CHAR_MAX];

void FindReqFile()
{
#if defined(PGSQL) || defined(MY_SQL)
    char s[CHAR_MAX];

    if( limit->protect == TRUE )
    {
	if( FTN_SYSTEM != PROTECT || FTN_SYSTEM_ST != PROTECT )
	{
	    log( "Freq file: \"%s\" - freq not allowed (protected system only!)", req->file );
	    rep_file( "%s - Your system is not allowed to freq this file",
		    req->file );
	    return;
	}
    }

    //    REQ,   ...
    if( FindREQEXEC() )
    {
	if( FindSQL() <= 0 )
	{
	    strcpy( s, req->file );
	    strcpy( req->file, strlwr( s ) );
	    FindSQL();
	}
    }
#endif	/* PGSQL || MYSQL */

    if( FIND )
    {
	rep_file( "%s - Not found", req->file );
	log( "Freq file: \"%s\" - Not found", req->file );
    }
}

int execreqok(char *file, char *str)
{
    int i = 0;
    char tmp[CHAR_MAX], *freq="\0", *newstr, *tok;

#ifdef	DEBUG
    printf( "str: \"%s\"\n", str );
#endif	/* DEBUG */

    strcpy( tmp, str );

    newstr = tmp;
    for( ; (char*)(tok = strtok( newstr, "," )); newstr = 0 )
    {
	//       ','.
	//  :  "<freq>, <exec programm> [, <file>]"
	switch( i )
	{
	    case 0:
		freq = tok;
#ifdef	DEBUG
		printf( "freq = \"%s\"", tok );
#endif	/* DEBUG */
		break;
	    case 1:
		strcpy( execfile, tok );
#ifdef	DEBUG
		printf( ", execfile = \"%s\"", execfile );
#endif	/* DEBUG */
		break;
	    case 2:
		strcpy( rreq, tok );
#ifdef	DEBUG
		printf( ", rreq = \"%s\"", rreq );
#endif	/* DEBUG */
		break;
	}
	i++;
    }
#ifdef	DEBUG
    printf( "\nfile = \"%s\", freq = \"%s\"\n", file, freq );
#endif	/* DEBUG */

    if( i >= 2 && !strcasecmp( file, freq ) )
    {
#ifdef	DEBUG
	printf( "strcasecmp() return 0\n" );
#endif	/* DEBUG */
	return( 0 );
    }
    return( -1 );
}

int FindREQEXEC()
{
    //    "" ...
    if( limit->reqexecbool == FALSE ) return( -1 );

#ifdef	DEBUG
    printf( "ExecFreq file: \"%s\"\n", req->file );
    printf( "REQ_EXEC = \"%d\"\n", REQ_EXEC );
#endif	/* DEBUG */

    if( gl->execreq[REQ_EXEC] != NULL )
    {
	for( execreq = gl->execreq[REQ_EXEC]; execreq != NULL;
			execreq = execreq->next )
	{
	    //   .
	    strcpy( execfile, "\0" );
	    strcpy( rreq, "\0" );
	    if( !execreqok( req->file, execreq->str ) )
	    {
		if( findok( rreq, execfile ) ) return( -1 );
		    return( 0 );
	    }
	}
    }
    return( -1 );
}

int findok(char *execreq, char *exec)
{
    int rc = 0;
    long size = 0;

    strcpy( find->file, execreq );
    strcpy( find->path, REQEXEC );
#ifdef	DEBUG
    printf( "path: %s\n",  find->path );
#endif	/* DEBUG */
    //  ,      REQEXEC 
    //   execreq!!!
    // TODO ---     ... ;(
    rc = execsh( exec );
    log( "Exec \"%s\", rc = %d", exec, rc );
#ifdef	DEBUG
    printf( "Exec \"%s\", rc = %d\n", exec, rc );
#endif	/* DEBUG */
    //   ...  0 --- ,    
    // !
    if( strlen( execreq ) != 0 ) size = sizefile();
    else strcpy( find->file, req->file ); // ???
    if( size == 0 && rc != 0 ) return( -1 );
    //    = 0   = 0 ---   
    //       (..   )
    if( size == 0 && rc == 0 )
    {
	//   ...
	log( "Freq file: \"%s\" (exec only) - Ok", find->file );
	//     .desc - ..    ...
	rep_file( "%s (exec only) - ExecFreqOk", find->file );
    }
    else
    {
	//   ...
	log( "Freq file: \"%s\" from \"%s\" (%db) - Ok",
	    find->file, find->path, find->size );
	//     .desc - ..    ...
	rep_file( "%s (%db) - ExecFreqOk", find->file, find->size );
    }
    //   OUT_FILE         ,
    //    ,    = 0.
    if( size > 0 && rc == 0 ) out_file();
    //   -    ...
//    NFILE++;
//    SIZE += find->size;
    FIND = 0;	//    0.
    return( 0 );
}
