#ifndef INCLUDES_H
#define INCLUDES_H

#define	NO_METOD 0
#define	WAZOO 1
#define	BARK 2

#define	PROTECT 0
#define	LISTED 1
#define	ALL 2
#define	UNPROTECT 3

#ifndef	TRUE
#define TRUE	1
#endif

#ifndef	FALSE
#define FALSE	0
#endif

#ifndef	ABORT
#define ABORT	-1
#endif

#include <limits.h>
#include "../tmalib/tmalib.h"
#include "../tmafreqlib/tmafreqlib.h"

/* wildcards.c */
//int wildcards(char*, char*);
/* req.c */
int req_file();
/* rep.c */
int rep_file(const char *format, ...);
/* rep_end.c */
void rep_end();
/* rep_begin.c */
void rep_begin();
/* out.c */
int out_file();
/* find.c */
void FindReqFile();
/* log.c */
int log(const char *format, ...);
/* size.c */
long sizefile();
/* time.c */
char *timenow();
char *today();
char *month1();
char *week();
void timer_init();
char *timer_stop();
/* skip_spaces.c */
char *skip_spaces(char*);
/* desc.c */
char *read_desc();
void free_desc();

#ifdef	PGSQL
#include <pgsql/libpq-fe.h>
PGconn	   *conn;
PGresult   *res;
PGresult   *res_tmp;
void exit_nicely(PGconn*);
int init_pgsql();
long size_daySQL();
int file_daySQL();
long size_weekSQL();
int file_weekSQL();
long size_monthSQL();
int file_monthSQL();
long TotalSizeSQL();
int TotalFileSQL();
int FindSQL();
#endif	/* PGSQL */

#ifdef	MY_SQL
#include <mysql.h>
MYSQL mysql,*sock;
MYSQL_FIELD *fields;
MYSQL_ROW row;
MYSQL_RES *res;
MYSQL_RES *res_tmp;
void exit_nicely(MYSQL*);
int init_mysql();
long size_daySQL();
int file_daySQL();
long size_weekSQL();
int file_weekSQL();
long size_monthSQL();
int file_monthSQL();
long TotalSizeSQL();
int TotalFileSQL();
int FindSQL();
#endif	/* MY_SQL */

#endif	/* INCLUDES_H */
