#include "includes.h"

LIMIT_TYPE *limit;
GLOBAL_TYPE *gl;

void rep_begin()
{
    rep_file( "# Address: %s", FTN_ADDR );
    rep_file( "# Speed:   %d", SPEED );

    switch( FTN_SYSTEM )
    {
	case PROTECT:
	    rep_file( "# System:  Protected" );
	    log( "Protected system, speed: %d", SPEED );
	    break;
	case UNPROTECT:
	    rep_file( "# System:  UnProtected" );
	    log( "UnProtected system, speed: %d", SPEED );
	    break;
	case LISTED:
	    rep_file( "# System:  Listed" );
	    log( "Listed system, speed: %d", SPEED );
	    break;
	case ALL:
	    rep_file( "# System:  Unlisted" );
	    log( "Unlisted system, speed: %d", SPEED );
	    break;
    }

    if( limit->no_limit == FALSE )
    {
	rep_file( "# Your limits (file/size):" );

	rep_file( "# Session:   %d / %db",
	 limit->file_session, limit->size_session );
	rep_file( "# Day:       %d / %db",
	 limit->file_day, limit->size_day );
	rep_file( "# Week:      %d / %db",
	 limit->file_week, limit->size_week );
	rep_file( "# Month:     %d / %db",
	 limit->file_month, limit->size_month );
	rep_file( "# Min speed: %d",
	 limit->lower_speed );
    }

    if( gl->string_2alt == TRUE )
    {
	    if( limit->string != NULL ) rep_file( "%s%s", CRLF,
		koi2alt( limit->string ) );
    }

    rep_file( "%s>-------------------------------------------------------------------------<%s", CRLF, CRLF );

    if( limit->no_limit == FALSE )
    {
	log( "Session limits: %d / %db", limit->file_session,
	 limit->size_session );
    }
    else log( "Session limits: no!" );
}
